# Contributing guidelines

## Contributing directly

At this point, the Millfork project uses Github for maintaining and distributing the project.

If you want to contribute:

* fork the master branch of the Millfork repository on Github;

* in your fork: implement something nice, fix some bugs, or improve documentation;

* make a pull request, explaining what you implemented if needed.

By making pull request, you agree for your changes to be distributed in perpetuity
under the applicable license (GPL-3 for the compiler, zlib for the stdlib, CC0 for documentation)
or any other compatible license.
You retain copyright to your contributions, you do not have to assign the copyright to anybody.

### Most wanted:

* programmers for 8-bit platforms who can add or improve support for their favourite machines.  
The supported (to various degrees) machines are [listed here](https://github.com/KarolS/millfork/blob/master/docs/api/target-platforms.md).     
The machines that could be supported, but are not yet, are [listed here](https://github.com/KarolS/millfork/issues/1).

* Scala programmers who can help with implementing the 6809 backend

## Contributing indirectly

If you want to help the project in a different way,
here are other ways you can help:

* reporting bugs and other issues: at https://github.com/KarolS/millfork/issues

* making feature requests: also at https://github.com/KarolS/millfork/issues

* giving advice

* benchmarking: feel free to contribute to https://github.com/KarolS/millfork-benchmarks

* simply using Millfork ☺
